/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.region.fixed;

import de.steamwar.bausystem.region.RegionData;
import de.steamwar.bausystem.region.RegionFlagPolicy;
import de.steamwar.bausystem.region.flags.Flag;
import lombok.NonNull;
import yapion.hierarchy.types.YAPIONObject;

public class FixedRegionData extends RegionData {

    public FixedRegionData(YAPIONObject data, Runnable onChange) {
        super(data, onChange);
    }

    @Override
    public @NonNull <T extends Enum<T> & Flag.Value<T>> RegionFlagPolicy has(@NonNull Flag<T> flag) {
        if (flag.oneOf(Flag.COLOR, Flag.TNT, Flag.FIRE, Flag.FREEZE, Flag.PROTECT, Flag.NO_GRAVITY, Flag.CHANGED, Flag.WATER_DESTROY)) {
            return RegionFlagPolicy.WRITABLE;
        }
        if (flag.oneOf(Flag.ITEMS)) {
            return RegionFlagPolicy.WRITABLE;
        }
        if (flag.oneOf(Flag.TESTBLOCK)) {
            return RegionFlagPolicy.READ_ONLY;
        }
        return RegionFlagPolicy.NOT_APPLICABLE;
    }
}
